#! /usr/bin/perl

foreach $_ (split(/:/, $ENV{'PATH'})) {
  push(@INC, $_), last if -f "$_/tfm.pl";
}
require 'tfm.pl';

@Ttou = @Tze;

if($ARGV[0] =~ /^-g$|^-ge/) {
  @Ttou = @Tzg;
} elsif($ARGV[0] =~ /^-e$|^-eg/) {
  @Ttou = @Tze;
} elsif($ARGV[0] =~ /^-ez/) {
  @Ttou = @Tez;
} elsif($ARGV[0] =~ /^-gz/) {
  @Ttou = @Tgz;
}

for($i = 0; $i <= 360; $i += 1) {
  $th = &rad($i);
  @pfrom = (cos($th), sin($th), 0);
  @pu = &v3mmul( @pfrom, @Ttou );
  ($lon, $lat) = &eq2dms( @pu );
  ($lh, $lm, $ls) = ($lon =~ /(\d+)/g);
  ($dd, $dm) = ($lat =~ /([-+]?\d+)/g);
  printf "%02d%02d%02d%s%02d000%s\n",
	$lh, $lm, $ls,
	$dd, $dm,
	$i==0 ? "VM" : "Vs";
}
